---
variables: 
  IMAGENAME: buildah
  DEPLOYVER: "latest"
  TF_VERSION: "1.1.7"
  PACKER_VERSION: "1.8.0"
  HASHICORP_PROVIDER_URL: "https://releases.hashicorp.com"

default:
  tags:
    - k3s
    - amd64
  image: registry.gitlab.com/buzzcrate/onelayer/runner-jammy/gitlab-runner:latest
  # image: registry.gitlab.com/buzzcrate/onelayer/runner-focal/gitlab-runner:latest
  # image: registry.gitlab.com/buzzcrate/onelayer/runner-focal/manual:latest 

stages: 
  - build
  - clear

.buildahlogin_template: &buildah_login
  before_script: 
    - echo "$PATH"
    - bash buildah.sh
    - bash install_runner.sh
    - sync
    # - buildah --help
    - buildah --version
    # - buildah --store-driver vfs
    - buildah login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

buildah_runner:
  stage: build
  variables: 
    IMAGENAME: gitlab-runner
  script:
    # - BUILDAH='buildah --storage-driver vfs'
    - bash buildah.sh
    # - sed -i 's/driver = \"overlay\"/driver = \"vfs\"/g' /etc/containers/storage.conf
    - buildah --version
    - container=$(buildah from scratch)
    - contmnt=$(buildah mount $container)
    - echo $contmnt
    - mkdir -p $contmnt/etc/apt
    # - curl http://archive.ubuntu.com/ubuntu/pool/main/u/ubuntu-keyring/ubuntu-keyring_2020.02.11.2.tar.gz -o keyring.tar.gz
    # - tar -xzf keyring.tar.gz
    - cp -r /etc/apt/trusted.gpg.d $contmnt/etc/apt/.
    - multistrap -f multistrap.config -d $contmnt
    - buildah run $container -- mkdir -p /runner
    - buildah config --workingdir /runner $container
    - cp -r *.sh $contmnt/runner/.
    - buildah run $container -- bash /runner/buildah.sh
    - buildah run $container -- bash /runner/install_runner.sh
    - buildah run $container -- apt clean
    - buildah run $container -- rm -rf /runner
    - buildah run $container -- buildah --version
    - sync
    # - buildah config --entrypoint 'bash /runner/register_runner.sh $REGISTRATION_TOKEN $RUNNER_NAME $RUNNER_TAG_LIST $EXECUTOR' $container
    - buildah config --arch amd64 $container
    - buildah config --label name=UbuntuRunner $container
    - buildah config --author "Will Christensen wirewc@gmail.com" $container
    # - buildah config --comment "Ubuntu Runner Container" $container
    - buildah commit $container $IMAGENAME:${DEPLOYVER}
    - imagehash=$(buildah images|grep $IMAGENAME|awk '{print $3}')
    - buildah  push $imagehash $CI_REGISTRY_IMAGE/$IMAGENAME:${DEPLOYVER}
    - buildah rmi $imagehash
    - buildah rm $container
  only:
    - main
<<: *buildah_login

buildah_runner_other:
  stage: build
  variables: 
    IMAGENAME: gitlab-runner
    DEPLOYVER: $CI_COMMIT_BRANCH
  script:
    # - BUILDAH='buildah --storage-driver vfs'
    - bash buildah.sh
    - sed -i 's/driver = \"overlay\"/driver = \"vfs\"/g' /etc/containers/storage.conf
    - buildah --version
    - container=$(buildah from scratch)
    - contmnt=$(buildah mount $container)
    - echo $contmnt
    - mkdir -p $contmnt/etc/apt
    # - curl http://archive.ubuntu.com/ubuntu/pool/main/u/ubuntu-keyring/ubuntu-keyring_2020.02.11.2.tar.gz -o keyring.tar.gz
    # - tar -xzf keyring.tar.gz
    - cp -r /etc/apt/trusted.gpg.d $contmnt/etc/apt/.
    - multistrap -f multistrap.config -d $contmnt
    - buildah run $container -- mkdir -p /runner
    - buildah config --workingdir /runner $container
    - cp -r *.sh $contmnt/runner/.
    - buildah run $container -- bash /runner/buildah.sh
    - buildah run $container -- bash /runner/install_runner.sh
    - buildah run $container -- apt clean
    - buildah run $container -- rm -rf /runner
    - buildah run $container -- buildah --version
    - sync
    # - buildah config --entrypoint 'bash /runner/register_runner.sh $REGISTRATION_TOKEN $RUNNER_NAME $RUNNER_TAG_LIST $EXECUTOR' $container
    - buildah config --arch amd64 $container
    - buildah config --label name=UbuntuRunner $container
    - buildah config --author "Will Christensen wirewc@gmail.com" $container
    # - buildah config --comment "Ubuntu Runner Container" $container
    - buildah commit $container $IMAGENAME:${DEPLOYVER}
    - imagehash=$(buildah images|grep $IMAGENAME|awk '{print $3}')
    - buildah  push $imagehash $CI_REGISTRY_IMAGE/$IMAGENAME:${DEPLOYVER}
    - buildah rmi $imagehash
    - buildah rm $container
  except:
    - main
    - clear
<<: *buildah_login


clearBuildahs:
  stage: clear
  script:  
    - buildah ls
    - buildah images
    - buildah rm $(buildah ls | grep -v ID | awk '{print $1}')
    - buildah rmi $(buildah images | grep -v ID | awk '{print $3}')
  only:
    - clear 
